<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="18">
        <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="0"
                 @submit.native.prevent>
          <el-form-item label="" prop="metricsName" style="margin-right:10px">
            <el-input
                v-model="queryParams.metricsName"
                placeholder="请输入指标名称"
                clearable
                @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="" prop="metricsTypes" style="margin-right:10px">
            <el-select v-model="queryParams.category" clearable placeholder="请选择指标分类">
              <el-option :label="item.typeName" :value="item.typeId" v-for="item in typeListData" :key="item.typeId"/>
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="metricsType" style="margin-right:10px">
            <el-select v-model="queryParams.metricsType" clearable placeholder="请选择指标类型">
              <el-option
                  v-for="dict in metrics_category"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <el-col :span="6" style="text-align: right">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['metrics:def:add']"
        >新增
        </el-button>
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="defList" border>
      <el-table-column label="指标ID" align="center" prop="metricsId" width="80"/>
      <el-table-column label="指标名称" align="left" prop="metricsName"/>
      <el-table-column label="指标分类" align="left" width="150">
        <template #default="scope">
          <span v-for="(item,i) in scope.row.metricsTypes" :key="`${scope.$index}_${item}`">
            {{ item.typeName }}<span v-if="i!==scope.row.metricsTypes.length-1">、</span>
          </span>
        </template>
      </el-table-column>
      <el-table-column label="指标类型" align="left" prop="metricsType" width="150">
        <template #default="scope">
          <dict-tag :options="metrics_category" :value="scope.row.metricsType"/>
        </template>
      </el-table-column>
      <el-table-column label="指标编码" align="left" prop="metricsCode" width="160"/>
      <el-table-column label="指标获取公式" align="left" prop="metricsExp"  width="330"/>
      <el-table-column label="更新时间" align="center" prop="updateTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d} {h}:{mi}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="left" class-name="small-padding fixed-width" width="200">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['metrics:def:edit']">
            修改
          </el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['metrics:def:remove']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改指标定义对话框 -->
    <el-dialog :title="title" v-model="open" width="800px" append-to-body>
      <el-form ref="defRef" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="指标类型" prop="metricsType">
          <el-select v-model="form.metricsType" placeholder="请选择指标类型">
            <el-option
                v-for="dict in metrics_category"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="指标名称" prop="metricsName">
          <el-input v-model="form.metricsName" placeholder="请输入指标名称"/>
        </el-form-item>
        <el-form-item label="指标编码" v-if="form.metricsCode">
<!--          <el-input v-model="form.metricsCode" placeholder="请输入指标编码"/>-->
          {{form.metricsCode}}
        </el-form-item>
        <el-form-item label="指标分类" prop="metricsTypes">
          <el-checkbox-group v-model="form.metricsTypes">
            <el-checkbox :label="item.typeName" v-for="item in typeListData" :key="item.typeId"/>
          </el-checkbox-group>
        </el-form-item>
        <el-form-item label="指标获取公式" prop="metricsExp">
          <el-input v-model="form.metricsExp" type="textarea" placeholder="请输入内容"/>
        </el-form-item>
        <el-form-item label="告警-低" prop="alarmLow">
          <el-input v-model="form.alarmLow" placeholder="请输入告警-低数值"/>
        </el-form-item>
        <el-form-item label="告警-中" prop="alarmMid">
          <el-input v-model="form.alarmMid" placeholder="请输入告警-中数值"/>
        </el-form-item>
        <el-form-item label="告警-高" prop="alarmHigh">
          <el-input v-model="form.alarmHigh" placeholder="请输入告警-高数值"/>
        </el-form-item>
        <el-form-item label="备注">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" :autosize="{maxRows:6,minRows:3}" maxlength="300" show-word-limit/>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Def">
import {addDef, delDef, getDef, listDef, updateDef} from "@/api/metrics/def";
import {listType} from "@/api/metrics/type";
import {onMounted} from "vue";

const {proxy} = getCurrentInstance();
const {metrics_category} = proxy.useDict('metrics_category');

const defList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const daterangeCreateTime = ref([]);
const daterangeUpdateTime = ref([]);

const typeListData = ref([])

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    metricsName: null,
    metricsCode: null,
    metricsType: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null,
    category: null,
  },
  rules: {
    metricsName: [
      {required: true, message: "指标名称不能为空", trigger: "blur"}
    ],
    metricsExp: [
      {required: true, message: "指标公式不能为空", trigger: "blur"}
    ],
    metricsType: [
      {required: true, message: "指标类型不能为空", trigger: "change"}
    ],
    metricsTypes: [
      {required: true, message: "指标分类不能为空", trigger: "change"}
    ]
  }
});

const {queryParams, form, rules} = toRefs(data);


/** 查询指标定义列表 */
function getList() {
  loading.value = true;
  queryParams.value.params = {};
  if (null != daterangeCreateTime && '' != daterangeCreateTime) {
    queryParams.value.params["beginCreateTime"] = daterangeCreateTime.value[0];
    queryParams.value.params["endCreateTime"] = daterangeCreateTime.value[1];
  }
  if (null != daterangeUpdateTime && '' != daterangeUpdateTime) {
    queryParams.value.params["beginUpdateTime"] = daterangeUpdateTime.value[0];
    queryParams.value.params["endUpdateTime"] = daterangeUpdateTime.value[1];
  }
  listDef(queryParams.value).then(response => {
    defList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

onMounted(() => {
  listType({pageNum: 1, pageSize: 20}).then(res => {
    typeListData.value = res.rows;
  });
})

// 表单重置
function reset() {
  form.value = {
    metricsId: null,
    metricsName: null,
    metricsCode: null,
    metricsExp: null,
    metricsType: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null,
    alarmHigh: null,
    alarmLow: null,
    alarmMid: null,
    metricsTypes: []
  };
  proxy.resetForm("defRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  daterangeCreateTime.value = [];
  daterangeUpdateTime.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加指标定义";

}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _metricsId = row.metricsId || ids.value
  getDef(_metricsId).then(response => {
    form.value = response.data;
    form.value.metricsTypes = form.value.metricsTypes.map(p => p.typeName)
    open.value = true;
    title.value = "修改指标定义";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["defRef"].validate(valid => {
    if (valid) {
      const pDate = {...form.value}
      let metricsTypesIds = []
      typeListData.value.forEach(item => {
        if (pDate.metricsTypes.includes(item.typeName)) {
          metricsTypesIds.push(item)
        }
      })
      pDate.metricsTypes = metricsTypesIds

      if (form.value.metricsId != null) {
        updateDef(pDate).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addDef(pDate).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _metricsIds = row.metricsId || ids.value;
  proxy.$modal.confirm('是否确认删除指标定义编号为"' + _metricsIds + '"的数据项？').then(function () {
    return delDef(_metricsIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {
  });
}

getList();
</script>
